'       3D RPG DEMO
'       Written by: DarkDread
'
'       Sorry it's not commented, I couldn't find the time to do that.  If
'       you can't understand some of the code feel free to e-mail me and
'       ask.  I'll be more than happy to help out.
'
'       E-mail me: liphilli@flemingc.on.ca
'       Visit me:  http://www.geocities.com/SiliconValley/Pines/1732/dds.htm
'
'       Let us begin...
'

DEFINT A-Z
'$DYNAMIC

DECLARE SUB ReadData ()
DECLARE SUB LoadGraphics ()
DECLARE SUB PrintMessage ()
DECLARE SUB SetupScreen ()
DECLARE SUB DrawLocation ()
DECLARE SUB MoveDown ()
DECLARE SUB MoveLeft ()
DECLARE SUB MoveRight ()
DECLARE SUB MoveUp ()

TYPE PlayerType
  Direction AS STRING * 1
END TYPE


DIM SHARED Player AS PlayerType
DIM SHARED X AS INTEGER
DIM SHARED Y AS INTEGER
DIM SHARED Moved AS INTEGER
DIM SHARED Noise AS INTEGER
DIM SHARED Dot AS STRING
DIM SHARED Answer AS STRING

DIM SHARED Maze(1 TO 29, 1 TO 19) AS INTEGER

DIM SHARED Back(4361) AS INTEGER
DIM SHARED DoorA1(2777) AS INTEGER
DIM SHARED DoorA2(1721) AS INTEGER
DIM SHARED DoorA3(1017) AS INTEGER
DIM SHARED WallA1(2777) AS INTEGER
DIM SHARED WallA2(1721) AS INTEGER
DIM SHARED WallA3(1017) AS INTEGER
DIM SHARED RightW1(797) AS INTEGER
DIM SHARED RightW2(533) AS INTEGER
DIM SHARED RightW3(357) AS INTEGER
DIM SHARED LeftW1(797) AS INTEGER
DIM SHARED LeftW2(533) AS INTEGER
DIM SHARED LeftW3(357) AS INTEGER
DIM SHARED Turn1(797) AS INTEGER
DIM SHARED Turn2(533) AS INTEGER
DIM SHARED Turn3(357) AS INTEGER

CONST True = -1, False = 0

Dot = CHR$(219)

CLS

CALL SetupScreen
CALL ReadData
CALL LoadGraphics

LOCATE 10, 1
COLOR 15
PRINT "Do you want sound? [y/n]"
Answer = LCASE$(INPUT$(1))
IF Answer = "y" THEN Noise = True

CALL PrintMessage

COLOR 15
SCREEN 13
  X = 4: Y = 4
  Player.Direction = "N"

LOCATE 4, 15: PRINT "3D RPG DEMO"
LOCATE 6, 5: PRINT "Left arrow key  -- Turn left"
LOCATE 7, 5: PRINT "Right arrow key -- Turn right"
LOCATE 8, 5: PRINT "Up arrow key    -- Go forward"
LOCATE 9, 5: PRINT "Esc key         -- Quit demo"
LOCATE 11, 6: PRINT "Press any key to begin...."
WHILE INKEY$ = "": WEND
CLS

Moved = True

CALL DrawLocation

DO
  Moved = False
  PSET (X, Y + 60), 120
  SELECT CASE INKEY$
    CASE CHR$(0) + CHR$(72)
      MoveUp
    CASE CHR$(0) + CHR$(80)
      MoveDown
    CASE CHR$(0) + CHR$(75)
      MoveLeft
    CASE CHR$(0) + CHR$(77)
      MoveRight
    CASE CHR$(27)
      Quit = True
  END SELECT
 
  PSET (X, Y + 60), 10
  IF Moved THEN CALL DrawLocation
 
  LOCATE 2, 2: PRINT "Maze   "; X; Y
  LOCATE 3, 2: PRINT "Compass "; Player.Direction
 
  IF Quit THEN EXIT DO
                                       
  FOR Pause = 1 TO 50: NEXT Pause

LOOP

SYSTEM

'=-=-=-=-=-=-=-=-=-=-=-=-=-=-= Data Begins Here -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
'=     The following lines of code are data for the 3-D mazes.  Each number, =
'= or block represents a square in the maze.  The zero means it's a walkable =
'= square.  Ones represent plain walls.  Higher numbers are different things =
'= on the walls such as torches, windows, doors and other graphics.          =
'=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

' Data for first maze
DATA 1,1,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1
DATA 0,1,1,1,1,1,1,1,0,0,1,0,1,0,0,0,0,1,0,0,0,0,1
DATA 0,1,0,0,1,0,0,1,0,1,1,0,1,0,1,1,0,1,0,0,0,0,1
DATA 0,1,1,1,1,1,1,1,1,1,0,0,1,0,0,1,0,1,0,0,0,0,1
DATA 0,0,0,1,0,0,0,0,0,1,0,0,1,1,1,1,0,1,0,0,0,0,1
DATA 0,1,0,1,0,1,1,1,0,1,1,1,0,0,0,0,0,1,0,0,0,0,1
DATA 0,1,1,1,0,0,1,0,0,1,0,1,0,1,1,1,1,1,0,0,0,0,1
DATA 1,1,0,1,1,1,1,1,1,1,0,1,1,1,0,0,0,1,0,0,0,0,1
DATA 1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1
DATA 1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1
DATA 0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
DATA 0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
DATA 0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1

REM $STATIC
DEFSNG A-Z
SUB DrawLocation
  IF Noise THEN PLAY "t255 l64 o0 e"
  PUT (112, 60), Back, PSET
  IF Player.Direction = "N" THEN
    '=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  Facing North
      IF Maze(X - 1, Y - 3) <> 1 AND Maze(X - 1, Y - 2) = 1 THEN
          PUT (142, 60), Turn3, PSET
        ELSEIF Maze(X - 1, Y - 2) <> 1 THEN
          PUT (142, 60), LeftW3, PSET
      END IF
      IF Maze(X - 1, Y - 2) <> 1 AND Maze(X - 1, Y - 1) = 1 THEN
          PUT (130, 60), Turn2, PSET
        ELSEIF Maze(X - 1, Y - 1) <> 1 THEN
          PUT (130, 60), LeftW2, PSET
      END IF
      IF Maze(X - 1, Y - 1) <> 1 AND Maze(X - 1, Y) = 1 THEN
          PUT (112, 60), Turn1, PSET
        ELSEIF Maze(X - 1, Y) <> 1 THEN
          PUT (112, 60), LeftW1, PSET
      END IF
      IF Maze(X + 1, Y - 3) <> 1 AND Maze(X + 1, Y - 2) = 1 THEN
          PUT (172, 60), Turn3, PSET
        ELSEIF Maze(X + 1, Y - 2) <> 1 THEN
          PUT (172, 60), RightW3, PSET
      END IF
      IF Maze(X + 1, Y - 2) <> 1 AND Maze(X + 1, Y - 1) = 1 THEN
          PUT (180, 60), Turn2, PSET
        ELSEIF Maze(X + 1, Y - 1) <> 1 THEN
          PUT (180, 60), RightW2, PSET
      END IF
      IF Maze(X + 1, Y - 1) <> 1 AND Maze(X + 1, Y) = 1 THEN
          PUT (192, 60), Turn1, PSET
        ELSEIF Maze(X + 1, Y) <> 1 THEN
          PUT (192, 60), RightW1, PSET
      END IF
      IF Maze(X, Y - 1) <> 1 THEN
          PUT (129, 60), WallA1, PSET
        ELSEIF Maze(X, Y - 2) <> 1 THEN
          PUT (142, 60), WallA2, PSET
        ELSEIF Maze(X, Y - 3) <> 1 THEN
          PUT (150, 60), WallA3, PSET
      END IF
    ELSEIF Player.Direction = "E" THEN
    '=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  Facing East
    IF Maze(X + 3, Y - 1) <> 1 AND Maze(X + 2, Y - 1) = 1 THEN
          PUT (142, 60), Turn3, PSET
        ELSEIF Maze(X + 2, Y - 1) <> 1 THEN
          PUT (142, 60), LeftW3, PSET
      END IF
      IF Maze(X + 2, Y - 1) <> 1 AND Maze(X + 1, Y - 1) = 1 THEN
          PUT (130, 60), Turn2, PSET
        ELSEIF Maze(X + 1, Y - 1) <> 1 THEN
          PUT (130, 60), LeftW2, PSET
      END IF
      IF Maze(X + 1, Y - 1) <> 1 AND Maze(X, Y - 1) = 1 THEN
          PUT (112, 60), Turn1, PSET
        ELSEIF Maze(X, Y - 1) <> 1 THEN
          PUT (112, 60), LeftW1, PSET
      END IF
      IF Maze(X + 3, Y + 1) <> 1 AND Maze(X + 2, Y + 1) = 1 THEN
          PUT (172, 60), Turn3, PSET
        ELSEIF Maze(X + 2, Y + 1) <> 1 THEN
          PUT (172, 60), RightW3, PSET
      END IF
      IF Maze(X + 2, Y + 1) <> 1 AND Maze(X + 1, Y + 1) = 1 THEN
          PUT (180, 60), Turn2, PSET
        ELSEIF Maze(X + 1, Y + 1) <> 1 THEN
          PUT (180, 60), RightW2, PSET
      END IF
      IF Maze(X + 1, Y + 1) <> 1 AND Maze(X, Y + 1) = 1 THEN
          PUT (192, 60), Turn1, PSET
        ELSEIF Maze(X, Y + 1) <> 1 THEN
          PUT (192, 60), RightW1, PSET
      END IF
      IF Maze(X + 1, Y) <> 1 THEN
          PUT (129, 60), WallA1, PSET
        ELSEIF Maze(X + 2, Y) <> 1 THEN
          PUT (142, 60), WallA2, PSET
        ELSEIF Maze(X + 3, Y) <> 1 THEN
          PUT (150, 60), WallA3, PSET
      END IF
    ELSEIF Player.Direction = "S" THEN
    '=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  Facing South
      IF Maze(X + 1, Y + 3) <> 1 AND Maze(X + 1, Y + 2) = 1 THEN
          PUT (142, 60), Turn3, PSET
        ELSEIF Maze(X + 1, Y + 2) <> 1 THEN
          PUT (142, 60), LeftW3, PSET
      END IF
      IF Maze(X + 1, Y + 2) <> 1 AND Maze(X + 1, Y + 1) = 1 THEN
          PUT (130, 60), Turn2, PSET
        ELSEIF Maze(X + 1, Y + 1) <> 1 THEN
          PUT (130, 60), LeftW2, PSET
      END IF
      IF Maze(X + 1, Y + 1) <> 1 AND Maze(X + 1, Y) = 1 THEN
          PUT (112, 60), Turn1, PSET
        ELSEIF Maze(X + 1, Y) <> 1 THEN
          PUT (112, 60), LeftW1, PSET
      END IF
      IF Maze(X - 1, Y + 3) <> 1 AND Maze(X - 1, Y + 2) = 1 THEN
          PUT (172, 60), Turn3, PSET
        ELSEIF Maze(X - 1, Y + 2) <> 1 THEN
          PUT (172, 60), RightW3, PSET
      END IF
      IF Maze(X - 1, Y + 2) <> 1 AND Maze(X - 1, Y + 1) = 1 THEN
          PUT (180, 60), Turn2, PSET
        ELSEIF Maze(X - 1, Y + 1) <> 1 THEN
          PUT (180, 60), RightW2, PSET
      END IF
      IF Maze(X - 1, Y + 1) <> 1 AND Maze(X - 1, Y) = 1 THEN
          PUT (192, 60), Turn1, PSET
        ELSEIF Maze(X - 1, Y) <> 1 THEN
          PUT (192, 60), RightW1, PSET
      END IF
      IF Maze(X, Y + 1) <> 1 THEN
          PUT (129, 60), WallA1, PSET
        ELSEIF Maze(X, Y + 2) <> 1 THEN
          PUT (142, 60), WallA2, PSET
        ELSEIF Maze(X, Y + 3) <> 1 THEN
          PUT (150, 60), WallA3, PSET
      END IF
    ELSEIF Player.Direction = "W" THEN
    '=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=  Facing West
      IF Maze(X - 3, Y + 1) <> 1 AND Maze(X - 2, Y + 1) = 1 THEN
          PUT (142, 60), Turn3, PSET
        ELSEIF Maze(X - 2, Y + 1) <> 1 THEN
          PUT (142, 60), LeftW3, PSET
      END IF
      IF Maze(X - 2, Y + 1) <> 1 AND Maze(X - 1, Y + 1) = 1 THEN
          PUT (130, 60), Turn2, PSET
        ELSEIF Maze(X - 1, Y + 1) <> 1 THEN
          PUT (130, 60), LeftW2, PSET
      END IF
      IF Maze(X - 1, Y + 1) <> 1 AND Maze(X, Y + 1) = 1 THEN
          PUT (112, 60), Turn1, PSET
        ELSEIF Maze(X, Y + 1) <> 1 THEN
          PUT (112, 60), LeftW1, PSET
      END IF
      IF Maze(X - 3, Y - 1) <> 1 AND Maze(X - 2, Y - 1) = 1 THEN
          PUT (172, 60), Turn3, PSET
        ELSEIF Maze(X - 2, Y - 1) <> 1 THEN
          PUT (172, 60), RightW3, PSET
      END IF
      IF Maze(X - 2, Y - 1) <> 1 AND Maze(X - 1, Y - 1) = 1 THEN
          PUT (180, 60), Turn2, PSET
        ELSEIF Maze(X - 1, Y - 1) <> 1 THEN
          PUT (180, 60), RightW2, PSET
      END IF
      IF Maze(X - 1, Y - 1) <> 1 AND Maze(X, Y - 1) = 1 THEN
          PUT (192, 60), Turn1, PSET
        ELSEIF Maze(X, Y - 1) <> 1 THEN
          PUT (192, 60), RightW1, PSET
      END IF
      IF Maze(X - 1, Y) <> 1 THEN
          PUT (129, 60), WallA1, PSET
        ELSEIF Maze(X - 2, Y) <> 1 THEN
          PUT (142, 60), WallA2, PSET
        ELSEIF Maze(X - 3, Y) <> 1 THEN
          PUT (150, 60), WallA3, PSET
      END IF
  END IF
END SUB

DEFINT A-Z
SUB LoadGraphics
  COLOR 14
  LOCATE 8, 16
  DEF SEG = VARSEG(Back(0)): BLOAD "BACK.BSG", VARPTR(Back(0))
  PRINT Dot;
  DEF SEG = VARSEG(Turn1(0)): BLOAD "T1.BSG", VARPTR(Turn1(0))
  PRINT Dot;
  DEF SEG = VARSEG(Turn2(0)): BLOAD "T2.BSG", VARPTR(Turn2(0))
  PRINT Dot;
  DEF SEG = VARSEG(Turn3(0)): BLOAD "T3.BSG", VARPTR(Turn3(0))
  PRINT Dot;
  DEF SEG = VARSEG(DoorA1(0)): BLOAD "DA1.BSG", VARPTR(DoorA1(0))
  PRINT Dot;
  DEF SEG = VARSEG(DoorA2(0)): BLOAD "DA2.BSG", VARPTR(DoorA2(0))
  PRINT Dot;
  DEF SEG = VARSEG(DoorA3(0)): BLOAD "DA3.BSG", VARPTR(DoorA3(0))
  PRINT Dot;
  DEF SEG = VARSEG(WallA1(0)): BLOAD "WA1.BSG", VARPTR(WallA1(0))
  PRINT Dot;
  DEF SEG = VARSEG(WallA2(0)): BLOAD "WA2.BSG", VARPTR(WallA2(0))
  PRINT Dot;
  DEF SEG = VARSEG(WallA3(0)): BLOAD "WA3.BSG", VARPTR(WallA3(0))
  PRINT Dot;
  DEF SEG = VARSEG(LeftW1(0)): BLOAD "LW1.BSG", VARPTR(LeftW1(0))
  PRINT Dot;
  DEF SEG = VARSEG(LeftW2(0)): BLOAD "LW2.BSG", VARPTR(LeftW2(0))
  PRINT Dot;
  DEF SEG = VARSEG(LeftW3(0)): BLOAD "LW3.BSG", VARPTR(LeftW3(0))
  PRINT Dot;
  DEF SEG = VARSEG(RightW1(0)): BLOAD "RW1.BSG", VARPTR(RightW1(0))
  PRINT Dot;
  DEF SEG = VARSEG(RightW2(0)): BLOAD "RW2.BSG", VARPTR(RightW2(0))
  PRINT Dot;
  DEF SEG = VARSEG(RightW3(0)): BLOAD "RW3.BSG", VARPTR(RightW3(0))
  PRINT Dot;
END SUB

DEFSNG A-Z
SUB MoveDown
  IF Player.Direction = "N" THEN
      IF Maze(X, Y + 1) = 1 THEN
        Moved = True
        Y = Y + 1
      END IF
    ELSEIF Player.Direction = "E" THEN
      IF Maze(X - 1, Y) = 1 THEN
        Moved = True
        X = X - 1
      END IF
    ELSEIF Player.Direction = "S" THEN
      IF Maze(X, Y - 1) = 1 THEN
        Moved = True
        Y = Y - 1
      END IF
    ELSEIF Player.Direction = "W" THEN
      IF Maze(X + 1, Y) = 1 THEN
        Moved = True
        X = X + 1
      END IF
  END IF
END SUB

SUB MoveLeft
  Moved = True
  IF Player.Direction = "S" THEN
      Player.Direction = "E"
    ELSEIF Player.Direction = "E" THEN
      Player.Direction = "N"
    ELSEIF Player.Direction = "N" THEN
      Player.Direction = "W"
    ELSEIF Player.Direction = "W" THEN
      Player.Direction = "S"
  END IF
END SUB

SUB MoveRight
  Moved = True
  IF Player.Direction = "S" THEN
      Player.Direction = "W"
    ELSEIF Player.Direction = "E" THEN
      Player.Direction = "S"
    ELSEIF Player.Direction = "N" THEN
      Player.Direction = "E"
    ELSEIF Player.Direction = "W" THEN
      Player.Direction = "N"
  END IF
END SUB

SUB MoveUp
  IF Player.Direction = "N" THEN
      IF Maze(X, Y - 1) = 1 THEN
        Moved = True
        Y = Y - 1
      END IF
    ELSEIF Player.Direction = "E" THEN
      IF Maze(X + 1, Y) = 1 THEN
        Moved = True
        X = X + 1
      END IF
    ELSEIF Player.Direction = "S" THEN
      IF Maze(X, Y + 1) = 1 THEN
        Moved = True
        Y = Y + 1
      END IF
    ELSEIF Player.Direction = "W" THEN
      IF Maze(X - 1, Y) = 1 THEN
        Moved = True
        X = X - 1
      END IF
  END IF
END SUB

SUB PrintMessage
  COLOR 15
  LOCATE 12
  PRINT "=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-="
  PRINT "= This  3D RPG  demo is  freeware.  Use it,  change it, abuse  it, but  don't ="
  PRINT "= forget to give me credit for it in your programs.                           ="
  PRINT "=                                                                Darkdread    ="
  PRINT "= E-mail me at: liphilli@flemingc.on.ca                                       ="
  PRINT "= Visit me at:  http://www.geocities.com/SiliconValley/Pines/1732/dds.htm     ="
  PRINT "=                                                                             ="
  PRINT "= Press <ENTER> to continue...                                                ="
  PRINT "=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-="
  INPUT "", Dummy$
END SUB

DEFINT A-Z
SUB ReadData
  COLOR 14
  LOCATE 6, 16
  FOR Y = 4 TO 16
    FOR X = 4 TO 26
      READ Maze(X, Y)
    NEXT X
    PRINT Dot;
  NEXT Y
END SUB

DEFSNG A-Z
SUB SetupScreen
  COLOR 15, 4
  LOCATE 1
  PRINT SPACE$(80)
  LOCATE 1, 28
  PRINT "3D Role Playing Game Engine"
  COLOR 15, 0
  LOCATE 3
  PRINT "Programmer:    Darkdread"
  PRINT "Copyright:     (c) 1997 DarkDreams Software"
  LOCATE 6
  PRINT "Loading data   ";
  COLOR 4
  PRINT ""
  COLOR 15
  LOCATE 8
  PRINT "Loading pics   ";
  COLOR 4
  PRINT ""
END SUB

